---
title: "Les données manquantes et non définies"
weight: 16
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<div id="données-manquantes" class="section level3">
<h3>Données manquantes</h3>
<ul>
<li>l’objet <code>NA</code> est un objet qui peut être présent à la fois dans un vecteur de nombres, de chaines de caractères ou d’objets d’une autre classe.</li>
</ul>
<p>Il signifie not available. L’information est manquante.</p>
<p>Si on doit faire la somme des revenus de deux individus, et qu’on ne connait qu’un des deux revenus n’a pas été mesuré (pour cause de non réponse par exemple), alors la somme des deux revenus ne peut être calculée. Elle est aussi manquante:</p>
<pre class="r"><code>NA+5</code></pre>
<pre><code>## [1] NA</code></pre>
<ul>
<li>Si on n’observe aucun des deux revenus, peut on dire qu’ils sont égaux ? Non:</li>
</ul>
<pre class="r"><code>NA==NA</code></pre>
<pre><code>## [1] NA</code></pre>
<ul>
<li>Comment alors tester qu’une donnée est manquante ? avec la fonction <code>is.na</code>.</li>
</ul>
<pre class="r"><code>is.na(c(NA,1,2,NA))</code></pre>
<pre><code>## [1]  TRUE FALSE FALSE  TRUE</code></pre>
</div>
<div id="exercice" class="section level3">
<h3>Exercice:</h3>
<p>Exécuter:</p>
<pre class="r"><code>set.seed(1);
x=1:1000
x[rbinom(1000,1,.2)==1]&lt;-NA</code></pre>
<p>Compter le nombre de valeur manquantes dans le vecteur <code>x</code></p>
<hr />
<details>
<summary>
Solution
</summary>
<pre class="r"><code>is.na(x)|&gt;
  sum()</code></pre>
<pre><code>## [1] 198</code></pre>
<pre class="r"><code>table(x,useNA=&quot;ifany&quot;)</code></pre>
<pre><code>## x
##    1    2    3    5    8    9   10   11   12   13   14   15   16   17   19   20 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##   22   23   24   25   26   27   28   30   31   32   33   34   36   37   38   39 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##   40   42   43   44   45   46   47   48   49   50   51   53   54   55   56   57 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##   58   59   60   62   63   64   65   66   67   68   69   71   73   74   75   78 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##   79   81   82   83   84   85   86   87   88   89   90   91   92   93   95   96 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##   97   98  100  101  102  103  105  106  107  108  110  112  113  114  115  116 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  117  118  119  120  122  123  124  125  126  127  128  129  130  131  132  133 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  134  136  137  138  140  141  142  143  144  145  146  147  148  149  151  152 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  153  154  155  156  157  158  159  160  161  163  164  166  167  168  169  170 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  171  174  175  177  178  179  181  182  184  186  187  188  190  191  192  193 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  195  196  197  199  200  201  202  203  204  205  206  207  208  209  210  212 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  213  216  217  220  221  222  223  224  226  227  228  229  231  232  233  234 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  235  236  237  238  239  240  241  242  244  245  246  247  248  249  251  253 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  254  255  256  257  258  259  261  262  263  264  265  266  267  268  269  270 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  271  272  273  274  275  276  277  278  279  280  281  282  284  285  286  287 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  288  289  290  291  292  294  295  296  297  298  299  301  302  303  304  305 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  307  309  310  311  312  314  315  316  317  318  320  321  322  323  328  329 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  330  332  333  335  336  337  338  339  342  343  344  345  346  347  348  349 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  350  351  352  353  354  356  358  360  361  362  364  365  367  368  369  370 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  371  372  374  375  376  377  379  380  381  382  383  385  386  387  389  391 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  392  394  395  396  397  398  399  400  401  402  406  407  408  409  412  413 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  414  415  416  417  418  419  421  422  423  424  425  426  427  432  433  434 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  435  437  438  439  441  442  443  444  445  446  447  449  450  452  453  454 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  455  456  457  459  460  461  462  463  464  465  467  468  469  470  471  473 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  474  475  476  478  479  480  481  482  485  486  487  488  490  491  493  494 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  495  496  497  498  500  501  502  503  504  505  507  509  510  512  513  514 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  515  516  517  518  519  520  522  523  524  525  528  531  532  533  534  535 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  536  537  538  539  540  541  543  544  545  546  548  549  550  552  553  555 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  556  557  558  561  562  563  564  566  567  568  569  571  572  573  574  576 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  577  578  580  581  583  584  585  586  587  588  590  591  592  593  594  596 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  597  598  599  600  603  604  607  608  610  612  613  614  615  616  617  618 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  619  620  622  623  624  625  626  627  628  629  632  633  635  636  637  638 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  639  640  642  644  645  646  647  649  651  653  654  655  656  657  658  659 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  661  662  663  664  665  666  668  669  670  671  672  674  675  676  677  678 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  679  680  681  682  683  684  685  686  687  688  689  691  692  694  695  696 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  697  698  700  703  704  705  706  707  708  710  711  712  713  714  715  716 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  717  718  719  720  721  722  724  725  727  728  729  730  731  732  733  734 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  735  736  737  739  740  741  742  743  744  745  746  747  749  750  751  753 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  754  755  756  757  758  760  761  762  764  765  766  767  768  770  771  773 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  775  776  777  778  779  782  783  784  786  787  788  789  790  791  792  794 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  795  796  797  798  800  802  804  805  806  807  809  810  811  812  813  815 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  816  819  820  821  822  823  826  827  828  829  830  831  834  835  836  837 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  840  842  843  844  845  846  847  848  849  850  852  853  855  856  857  858 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  859  860  861  862  863  864  865  866  867  868  869  870  871  874  875  876 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  877  878  879  881  885  886  888  889  890  891  892  893  894  895  896  897 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  898  899  900  902  903  904  905  906  907  908  909  910  911  912  913  914 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  915  916  917  918  919  921  924  927  928  929  930  931  933  934  935  936 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  938  940  941  943  944  945  946  947  948  951  952  953  955  956  958  959 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  960  961  962  963  964  965  966  967  970  972  973  975  976  977  978  979 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  981  982  984  985  986  987  988  990  991  992  993  994  995  996  997  998 
##    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1 
##  999 1000 &lt;NA&gt; 
##    1    1  198</code></pre>
</details>
<hr />
</div>
<div id="données-mal-définies" class="section level3">
<h3>Données mal définies</h3>
<p>A quoi égale 0/0?
Ce n’est pas défini.</p>
<p>En R, non défini se dit <code>NaN</code>.</p>
<pre class="r"><code>0/0</code></pre>
<pre><code>## [1] NaN</code></pre>
<p>Quelque chose de non défini plus quelque chose de défini donne un résultat non défini:</p>
<pre class="r"><code>NaN+5</code></pre>
<pre><code>## [1] NaN</code></pre>
<p>Comment tester si quelque chose est non défini ?</p>
<pre class="r"><code>NaN==5</code></pre>
<pre><code>## [1] NA</code></pre>
<pre class="r"><code>is.na(NaN)</code></pre>
<pre><code>## [1] TRUE</code></pre>
<p>De façon pratique, il suffit d’utiliser encore <code>is.na</code></p>
</div>
<div id="se-débarasser-des-valeurs-manquantes." class="section level3">
<h3>Se débarasser des valeurs manquantes.</h3>
<ul>
<li>Remplacer toutes les valeurs par 0:</li>
</ul>
<pre class="r"><code>x=sample(c(NA,1),1000,T)
ifelse(is.na(x),0,x)</code></pre>
<pre><code>##    [1] 1 1 0 0 0 0 1 1 0 1 0 1 1 1 1 1 1 0 1 0 1 1 0 0 1 0 1 0 0 1 0 1 0 0 1 0 0
##   [38] 1 0 1 1 1 1 1 0 0 1 1 0 0 1 0 0 1 1 0 1 0 0 1 1 1 1 1 0 0 0 1 0 1 0 0 1 0
##   [75] 0 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 1 1 1 0 0 1 0 1 1 1 0 1 1 0 0 1 1 1 0 0
##  [112] 0 0 0 1 1 0 1 1 1 1 0 0 0 0 1 1 0 0 1 0 1 0 0 1 1 0 0 1 0 1 0 0 0 1 0 1 0
##  [149] 1 1 1 0 0 1 0 0 1 1 1 1 0 1 1 1 1 0 0 1 0 1 1 0 1 0 0 1 1 1 1 1 0 0 1 1 0
##  [186] 0 1 0 0 0 1 1 1 0 1 0 1 0 1 0 0 1 0 1 0 1 0 0 1 1 1 1 0 0 1 0 1 1 1 0 0 1
##  [223] 0 1 0 0 0 0 1 0 1 1 1 1 0 0 1 1 1 0 1 0 1 0 0 0 0 1 1 1 0 0 0 1 0 0 1 0 1
##  [260] 1 0 1 0 1 1 1 0 0 0 1 1 0 0 1 0 0 0 0 1 1 1 1 1 1 0 0 1 0 0 0 0 0 1 1 1 0
##  [297] 1 0 0 0 1 1 0 0 1 1 1 1 1 0 1 0 1 1 0 0 1 0 1 0 1 1 0 1 1 1 1 1 1 0 0 0 1
##  [334] 1 1 1 0 1 0 1 1 0 1 1 1 0 0 0 1 0 0 0 0 1 1 0 1 0 0 0 0 0 0 1 1 1 0 0 1 1
##  [371] 1 0 1 1 1 1 1 1 1 0 1 1 1 0 0 0 1 0 0 1 0 0 0 1 0 1 0 1 1 1 0 1 1 0 0 0 1
##  [408] 1 0 0 0 1 1 1 0 1 1 0 0 0 0 0 1 0 1 1 0 0 0 0 1 1 0 1 1 1 0 1 0 1 1 0 1 1
##  [445] 0 0 0 1 0 0 1 0 0 0 1 1 1 1 1 0 0 0 1 0 0 1 0 1 0 0 0 0 1 1 0 1 1 1 0 0 1
##  [482] 1 1 1 0 1 1 0 0 0 0 1 1 1 1 0 0 1 0 0 0 0 1 0 0 1 1 1 0 1 1 1 0 0 0 0 0 0
##  [519] 1 1 1 0 1 0 1 0 1 1 1 1 0 1 0 0 0 1 0 0 1 0 0 0 0 1 0 0 0 1 1 1 1 0 0 0 0
##  [556] 0 0 0 1 0 0 0 1 0 1 0 0 0 0 1 0 0 0 0 0 0 0 0 1 1 0 1 1 1 0 1 0 1 1 1 0 1
##  [593] 0 0 1 0 0 0 0 0 1 0 0 0 1 0 1 0 1 0 1 1 0 0 1 0 1 0 0 0 0 1 0 1 0 0 0 0 0
##  [630] 0 1 1 0 0 1 0 1 1 0 1 0 1 0 1 1 1 1 1 0 1 0 1 0 0 1 0 1 1 0 1 1 1 1 1 0 0
##  [667] 0 1 1 0 0 0 1 1 0 1 1 0 0 0 1 0 0 0 0 1 1 1 0 0 0 0 0 1 0 1 1 0 0 0 0 1 1
##  [704] 0 1 0 1 1 0 0 1 0 0 0 1 1 0 1 0 0 1 0 1 1 0 0 0 0 0 0 1 1 0 0 1 1 1 0 1 1
##  [741] 1 1 1 0 1 0 0 0 0 1 1 0 0 1 1 0 0 0 1 1 1 0 0 0 1 0 1 0 0 1 0 1 0 0 1 0 1
##  [778] 1 0 1 0 1 1 0 0 0 0 0 1 1 1 0 1 1 0 0 0 0 0 1 1 0 0 1 1 0 0 0 1 1 0 0 1 1
##  [815] 1 1 1 0 1 1 1 1 0 1 0 1 0 1 0 1 1 1 0 1 1 0 0 1 1 1 0 1 1 1 0 1 1 1 0 1 1
##  [852] 1 0 1 1 0 1 1 1 1 0 1 1 0 0 0 1 1 0 0 0 1 1 0 0 0 0 0 0 1 1 0 1 0 1 1 0 1
##  [889] 1 1 0 0 1 1 0 0 1 1 0 1 0 1 1 0 1 1 1 0 1 0 0 1 1 1 1 1 1 1 0 1 0 0 0 0 0
##  [926] 1 1 0 0 0 0 0 1 0 0 1 1 1 0 1 0 0 1 0 1 1 1 1 1 0 1 0 1 0 0 1 0 0 0 0 1 0
##  [963] 1 0 1 1 0 0 1 1 0 1 0 0 0 1 0 1 0 0 0 1 0 1 0 1 1 0 1 1 0 1 0 1 0 0 0 0 0
## [1000] 1</code></pre>
<ul>
<li>Utiliser les options des fonctions.</li>
</ul>
<pre class="r"><code>sum(x)</code></pre>
<pre><code>## [1] NA</code></pre>
<pre class="r"><code>sum(x,na.rm=T)</code></pre>
<pre><code>## [1] 497</code></pre>
<pre class="r"><code>mean(x,na.rm=T)</code></pre>
<pre><code>## [1] 1</code></pre>
<pre class="r"><code>min(x,na.rm=T)</code></pre>
<pre><code>## [1] 1</code></pre>
</div>
